/**************************************************************************\
  class InputStream
  =================

  istream-type class which keeps track of the current line number
\**************************************************************************/

#ifndef _INPUTSTREAM_H_
#define	_INPUTSTREAM_H_

#include <string>
#include <cctype>
#include <iostream>

class InputStream
{
public:
    inline InputStream(std::istream& istr): is(istr), lineNumber(1) {}

    inline bool good() const { return is.good(); }

    inline char peek() const { return is.peek(); }
    inline char get()
    { char c=is.get(); if(c=='\n') lineNumber++;
      return c; }

    inline void getline(std::string& s, char delim='\n')
    { s.erase(); do { s+=get(); } while(s[s.size()-1] != delim); }

    inline InputStream& operator>>(char& c)
    { while(isspace(c=get())); return *this; }

    inline unsigned LineNumber() const { return lineNumber; }

private:
    std::istream& is;
    unsigned lineNumber;
};

#endif
